<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp06500LogDeAutorizacaoDeFornecimento extends \Zeedhi\Framework\Controller\Report {
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $stNomeRel;
    protected $filialService;
    
    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection, $dataSourceManager, $filialService) {
        $this->entityManager     = $entityManager;
        $this->qr2Strategy       = $qr2Strategy;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->filialService     = $filialService;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        $row = $request->getRow();
        
        $cdOperador = $this->environment->getCdOperador();
        
        if($row["FILIALDEST"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["FILIALDEST"] = $newFilial;
                }
        }
        
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =    
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                array (
                    "OPERADOR"      => "L_OPERADOR",
                    "FILIALDEST"    => "L_FILIAL",
                    "DTINI"         => "P_DTI",
                    "DTFIM"         => "P_DTF",
                    "DATAINIC"      => "P_DATAINIC",
                    "DATAFINA"      => "P_DATAFINA",
                    "NRAUTFOR"      => "L_NRAUTFOR",
                    "CDPRODINI"     => "P_CDPRODINI",
                    "CDPRODFIN"     => "P_CDPRODFIN",
                    "TCDPRODUTO"    => "P_TCDPRODUTO"
                ),
            );
    }
}
