/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LOGOCIA                                                  */
/* Tabela : LOGOCIA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_LOGOCIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_LOGOCIA
GO

CREATE TRIGGER DTULTATU_LOGOCIA
ON LOGOCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'LOGOCIA', null, 'CDCIA='+ CDCIA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE LOGOCIA
      SET DTULTATULOGO = GETDATE()
      FROM INSERTED;
   END;
END;
GO

