function Cmp04100BaixaAFsController(ScreenService, General, Utilities, templateManager, MessageService) {
	
	function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
	
	function concatenaEscolhas(currentRow) {

		let escolhas = '';
		let array = currentRow.ESCOLHAS;
		
		currentRow.P_IDBAIXAAF_NULL = "Z";
    
        for(let i = 0; i<array.length; i++){
            
            switch (array[i]) {
        	    case '0':
        	        escolhas += '1';
        	        break;
        	    case '1':
        	        escolhas += '_2';
        	        break;
        	    case '2':
        	        escolhas += '_3';
        	        break;
        	    case '3': 
        	        escolhas += '_4';
        	        break;
        	    case '4':
        	        escolhas += '_5';
        	        break;
        	    case '5':
        	        currentRow.P_IDBAIXAAF_NULL = "X";
        	        break;
        	}
        }	
		
		if (escolhas === '') escolhas = '0';
    	if (escolhas !== '') currentRow.P_IDBAIXAAF = escolhas;

		currentRow.CDPRODFIM = currentRow.CDPRODFINAL;
		currentRow.CDPRODINI = currentRow.CDPRODUTO;
		currentRow.DATAINI 	 = currentRow.INTERVALO_DATA.start;
		currentRow.DATAFIN 	 = currentRow.INTERVALO_DATA.end;
		currentRow.NRORG 	 = getLocalVar('NRORG');
	}

    this.productValidations = function(field) {
        const row         = field.widget.currentRow;
        const prodInicial = row.CDARVPRODINI;
        const prodFinal   = row.CDARVPRODFIM;
        
        if(!validaProduto(prodInicial, prodFinal)){
            field.clearValue();
        }
    };

	this.validaReport = function(widget, currentRow) {

		if(widget.isValid()) {
			if(!Util.isEmptyObject(currentRow.ESCOLHAS)){
				General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow.REPORT_NAME, currentRow]);
			} else {
				MessageService.showMessageByCode("SITUACAO_AF_SELECT");
			}
		} else {
			MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
		}

	};

	this.abreRelatorio = function(widget, reportName, currentRow) {
		
		if(!window.projectCorp)
			currentRow.NMFILIAL = getLocalVar('CDFILIAL');
			
		currentRow.LISTAFILIAIS = !Util.isEmptyOrBlank(currentRow.NMFILIAL) ? currentRow.NMFILIAL.join('_') : 'T';
		currentRow.DTINICIAL    = currentRow.INTERVALO_DATA.start;
		currentRow.DTFINAL      = currentRow.INTERVALO_DATA.end;
		
		concatenaEscolhas(currentRow);
	
        General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp04100_baixa_afs', reportName, currentRow);

	}.bind(this);

	this.setInitValues = function(widget) {
	    
	    const filialField = widget.getField("CDFILDEST");
            
        filialField.value(getLocalVar("NMFILIAL"));
	    
	    General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
	        const filterRow = {
        	    INTERVALO_DATA : {
                    'formattedStart' : moment().format('DD/MM/YYYY'),
                    'start'          : moment().format('DD/MM/YYYY'),
                    'formattedEnd'   : moment().format('DD/MM/YYYY'),
                    'end'            : moment().format('DD/MM/YYYY')
                },
                IDBAIXAAF : [ "0", "1", "2", "3" ],
                NMIDBAIXAAF : [ "Em Aberto", "Baixa Parcial", "Baixa Total", "Baixa Manual" ],
                IDAFEXPIRADA : "T",
                CDFILDEST: [ getLocalVar("CDFILIAL") ],
                NMFILDEST: [ getLocalVar("NMFILIAL") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILDEST = [ CDFILCENTCMP ];
                filterRow.NMFILDEST = [ NMFILCENTCMP ];
                filialField.value(NMFILCENTCMP);
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == filterRow.CDFILDEST[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILDEST;
    	               delete filterRow.NMFILDEST;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILDEST[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILDEST;
    	                   delete filterRow.NMFILDEST;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
       
		    Utilities.startFilter(widget, filterRow);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
        
        
    };
    
    this.skipFilterZeedhi = function(args) {
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.setDataSourceFilterBaixaAf = function (args) {
    	const row                   = args.e.preference.FILTER_ROW;
        const widget                = templateManager.container.getWidget('cmp04100');
        const filterPopupCurrentRow = widget.appliedFilter.FILTER_ROW;
        
        widget.dataSourceFilter = [
            {
    			"name": "P_DTINI",
    			"operator": "=",
    			"value": row.INTERVALO_DATA.start
    		},
    		{
    		    "name": "P_DTFIN",
    			"operator": "=",
    			"value": row.INTERVALO_DATA.end
    		},
    		{
    			"name": "L_CDFILIAL",
    			"operator": "=",
    			"value": !row.CDFILDEST || Util.isEmptyObject(row.CDFILDEST) ? 'T' : row.L_CDFILIAL = '_' + row.CDFILDEST.join('_') + '_'
    		},
    		{
    	    	"name": "P_CDPRODINI",
    			"operator": "=",
    			"value": row.CDARVPRODINI
    		},
    		{
    			"name": "P_CDPRODFIN",
    			"operator": "=",
    			"value": row.CDARVPRODFIM.padEnd(20,'Z')
    		},
    		{
    			"name": "P_IDBAIXAAF",
    			"operator": "=",
				"value": row.IDBAIXAAF.join('_')
			},
			{
    	    	"name": "P_IDAFEXPIRADA",
    			"operator": "=",
    			"value": row.IDAFEXPIRADA
    		},
    		{
				"name": "P_MODO",
				"operator": "=",
				"value": 'N'
			},
			{
			    "name": "P_CDOPERADOR",
			    "operator": "=",
			    "value": getLocalVar("CDOPERADOR")
			}
		];
    	
       	widget._filterInfo = [
       	    { "label": ScreenService.i18n("Unidade Destino"), "value" : concatArrayForParams(filterPopupCurrentRow.NMFILDEST, ScreenService.i18n("Todas"))},
            { "label": ScreenService.i18n("Situação da AF"),  "value" : concatArrayForParams(setBaixaAF(filterPopupCurrentRow.IDBAIXAAF), ScreenService.i18n("Todas"))},
            { "label": ScreenService.i18n("AF Expirada"),     "value" : filterPopupCurrentRow.IDAFEXPIRADA == 'T' ? ScreenService.i18n("Todas") : filterPopupCurrentRow.IDAFEXPIRADA == 'N' ? ScreenService.i18n("Não") : ScreenService.i18n("Sim")},
            { "label": ScreenService.i18n("Data de Entrega"), "value" : filterPopupCurrentRow.INTERVALO_DATA.formattedStart + ' a ' + filterPopupCurrentRow.INTERVALO_DATA.formattedEnd},
            { "label": ScreenService.i18n("Produto Inicial"), "value" : filterPopupCurrentRow.NMPRODUTOINI},
            { "label": ScreenService.i18n("Produto Final"),   "value" : filterPopupCurrentRow.NMPRODUTOFIM},
        ];
        		
        widget.reload();
        widget.activate();
        setStripeValues(filterPopupCurrentRow);
    };
    
    function setStripeValues(filterPopupCurrentRow) {
        const stripe = templateManager.container.getWidget('FILTERSTRIPE');
        
        stripe.currentRow.NMFILDEST      = concatArrayForParams(filterPopupCurrentRow.NMFILDEST, ScreenService.i18n("Todas")).replaceAll("_", ", ");
        stripe.currentRow.IDBAIXAAF      = concatArrayForParams(setBaixaAF(filterPopupCurrentRow.IDBAIXAAF), ScreenService.i18n("Todas")).replaceAll("_", ", ");
        stripe.currentRow.IDAFEXPIRADA   = filterPopupCurrentRow.IDAFEXPIRADA == 'T' ? ScreenService.i18n("Todas") : filterPopupCurrentRow.IDAFEXPIRADA == 'N' ? ScreenService.i18n("Não") : ScreenService.i18n("Sim");
        stripe.currentRow.INTERVALO_DATA = filterPopupCurrentRow.INTERVALO_DATA.start + " à " + filterPopupCurrentRow.INTERVALO_DATA.end;
        stripe.currentRow.NMPRODUTOINI   = filterPopupCurrentRow.NMPRODUTOINI;
        stripe.currentRow.NMPRODUTOFIM   = filterPopupCurrentRow.NMPRODUTOFIM;
    }
    
    function setBaixaAF(IDBAIXAAF) {
        let baixa = [];
    	
    	IDBAIXAAF.forEach(function(idBaixa){
            switch (idBaixa) {
        	    case '0':
        	        baixa.push(ScreenService.i18n('Em Aberto'));
        	        break;
        	    case '1':
        	        baixa.push(ScreenService.i18n('Baixa Parcial'));
        	        break;
        	    case '2':
        	        baixa.push(ScreenService.i18n('Baixa Total'));
        	        break;
        	    case '3':
        	        baixa.push(ScreenService.i18n('Baixa Manual'));
        	        break;
        	    case '4':
        	        baixa.push(ScreenService.i18n('Encerrada'));
        	        break;
        	    case '5':
        	        baixa.push(ScreenService.i18n('Cancelada'));
        	        break;
        	    case 'S':
        	        baixa.push(ScreenService.i18n('Expirada'));
        	        break;
        	}
        });
        
        return baixa;
    }
    
    function validaProduto(prodInicial, prodFinal) {
        
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }
        return true;
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04100BaixaAFsController', Cmp04100BaixaAFsController);
});